/****************************************************************************

	Copyright (c) 1998 Samizdat Productions. All Rights Reserved.
	You may use and redistribute this file subject to the restrictions
	outlined in the file 'readme.html', which is included with this
	package.

	For more free Java tools, applets, and applications, be sure and
	visit us at <http://www.tolstoy.com>. 

	See <http://www.tolstoy.com/samizdat/JavaSamples.html> for the latest
	version of this package.

	For more information, send email to <samizdat@tolstoy.com>

****************************************************************************/

package COM.tolstoy.nativetest;

//	this sample application tests the native DLLs

public class NativeTest {
	public static void main( String args[] ) {
		loadTheLibrary();
		doIntTest();
		doLongTest();
		doStringTest();
	}

		//	totals the elements in 'inArray', and returns the number of elements in 'inArray' in
		//	the first element of 'outArray', and the total in the second element of 'outArray'

	private static native int intTest( int inArray[], int outArray[] );

		//	same as intTest, except uses longs

	private static native long longTest( long inArray[], long outArray[] );
	
		//	add 1 to each character of 's', and puts the modified string in each
		//	element of 'outArray'

	private static native int stringTest( String s, String outArray[] );

		//	the following test the native methods and print the results

	private static void doIntTest() {
		int		in[] = { 37, 14, 24, 21, 37 }, out[] = new int[ 2 ];
		
		intTest( in, out );
		System.out.println( "intTest: # of ints=" + out[ 0 ] + ", total=" + out[ 1 ] );
	}

	private static void doLongTest() {
		long		in[] = { 37, 14, 24, 21, 37 }, out[] = new long[ 2 ];
		
		longTest( in, out );
		System.out.println( "longTest: # of longs=" + out[ 0 ] + ", total=" + out[ 1 ] );
	}

	private static void doStringTest() {
		String		out[] = new String[ 3 ];
		int			i;
		
		stringTest( "samizdat", out );
		for ( i = 0; i < 3; i++ )
			System.out.println( "stringTest: at " + i + " is " + out[ i ] );
	}

		// depending on which VM we're running, load the appropriate native code DLL

	private static void loadTheLibrary() {
		try {
			if ( System.getProperty( "java.vendor" ).toLowerCase().indexOf( "microsoft" ) >= 0 )
				Runtime.getRuntime().loadLibrary( "ntestMS" );
			else
				Runtime.getRuntime().loadLibrary( "ntestSN" );
		}
		catch ( Exception e ) {
			System.out.println( "loadTheLibrary, e=" + e );
		}
		catch ( Error er ) {
			System.out.println( "loadTheLibrary, er=" + er );
		}
	}
}

		
