/****************************************************************************

	Copyright (c) 1998 Samizdat Productions. All Rights Reserved.
	You may use and redistribute this file subject to the restrictions
	outlined in the file 'readme.html', which is included with this
	package.

	For more free Java tools, applets, and applications, be sure and
	visit us at <http://www.tolstoy.com>. 

	See <http://www.tolstoy.com/samizdat/JavaSamples.html> for the latest
	version of this package.

	For more information, send email to <samizdat@tolstoy.com>

****************************************************************************/

#include "JNIUtils.h"
#include <string.h>

#ifdef __cplusplus
	#define	GETSTRINGUTFCHARS(a)				pEnv->GetStringUTFChars( (a), 0 )
	#define	RELEASESTRINGUTFCHARS(a,b)			pEnv->ReleaseStringUTFChars( (a), (b) )
#else
	#define	GETSTRINGUTFCHARS(a)				( *pEnv )->GetStringUTFChars( pEnv, (a), 0 )
	#define	RELEASESTRINGUTFCHARS(a,b)			( *pEnv )->ReleaseStringUTFChars( pEnv, (a), (b) )
#endif

char *JNIUtils_GetString( JNIEnv *pEnv, jstring pStr, char *strP, jint len )
{
	const char		*tempP;

	if ( len < 1 || strP == NULL )
		return strP;

	tempP = GETSTRINGUTFCHARS( pStr );
	strncpy( strP, tempP, len );
	strP[ len - 1 ] = 0;
	RELEASESTRINGUTFCHARS( pStr, tempP );
	
	return strP;
}

