/****************************************************************************

	Copyright (c) 1998 Samizdat Productions. All Rights Reserved.
	You may use and redistribute this file subject to the restrictions
	outlined in the file 'readme.html', which is included with this
	package.

	For more free Java tools, applets, and applications, be sure and
	visit us at <http://www.tolstoy.com>. 

	See <http://www.tolstoy.com/samizdat/JavaSamples.html> for the latest
	version of this package.

	For more information, send email to <samizdat@tolstoy.com>

****************************************************************************/

#ifndef INC_JNIUtils_H
#define INC_JNIUtils_H

#include <windows.h>
#include <jni.h>

#define	kErrParamErr		-50

#define EXP JNIEXPORT

#define	FUNC(pkg,clz,mth)			JNICALL Java_COM_tolstoy_##pkg##_##clz##_##mth(	\
									JNIEnv *pEnv,	\
									jclass pObj

#define JSTRING						jstring
#define JINT						jint
#define	JLONG						jlong
#define JINTARRAY					jintArray
#define	JLONGARRAY					jlongArray
#define	JSTRINGARRAY				jobjectArray

#define	CHECKNULL(a)				{ if ( (a) == NULL ) return kErrParamErr; }

#ifdef __cplusplus
	#define CHECKSIZE( a, b )					{ if ( ( (a) == NULL ) || ( pEnv->GetArrayLength( (a) ) < (b) ) ) \
													return kErrParamErr; }
	#define	GETINTARRAYLEN(a)					pEnv->GetArrayLength( (a) )
	#define	LOCKINTARRAY(a)						pEnv->GetIntArrayElements( (a), 0 )
	#define	UNLOCKINTARRAY(a,b)					pEnv->ReleaseIntArrayElements( (a), (b), 0 )
	#define	SETINTARRAY(a,b,c,d)				pEnv->SetIntArrayRegion( (a), (b), (c), (d) );	

	#define	GETLONGARRAYLEN(a)					pEnv->GetArrayLength( (a) )
	#define	LOCKLONGARRAY(a)					pEnv->GetLongArrayElements( (a), 0 )
	#define	UNLOCKLONGARRAY(a,b)				pEnv->ReleaseLongArrayElements( (a), (b), 0 )
	#define	SETLONGARRAY(a,b,c,d)				pEnv->SetLongArrayRegion( (a), (b), (c), (d) );	

	#define	GETOBJECTARRAYLEN(a)				pEnv->GetArrayLength( (a) )
	#define	GETOBJECTARRAYELEMENT( a, b )		pEnv->GetObjectArrayElement( (a), (b) )
	#define	SETOBJECTARRAYELEMENT( a, b, c )	pEnv->SetObjectArrayElement( (a), (b), (c) )

	#define	NEWSTRINGUTF( a )					pEnv->NewStringUTF( (a) )
	#define	GETSTRINGUTFLEN(a)					pEnv->GetStringUTFLength( (a) )
	#define	GETSTRINGUTF(a,b,c)					JNIUtils_GetString( pEnv, (a), (b), (c) )

#else
	#define CHECKSIZE( a, b )					{ if ( ( (a) == NULL ) || ( ( *pEnv )->GetArrayLength( pEnv, (a) ) < (b) ) ) \
													return kErrParamErr; }
	#define	GETINTARRAYLEN(a)					( *pEnv )->GetArrayLength( pEnv, (a) )
	#define	LOCKINTARRAY(a)						( *pEnv )->GetIntArrayElements( pEnv, (a), 0 )
	#define	UNLOCKINTARRAY(a,b)					( *pEnv )->ReleaseIntArrayElements( pEnv, (a), (b), 0 )
	#define	SETINTARRAY(a,b,c,d)				( *pEnv )->SetIntArrayRegion( pEnv, (a), (b), (c), (d) );	

	#define	GETLONGARRAYLEN(a)					( *pEnv )->GetArrayLength( pEnv, (a) )
	#define	LOCKLONGARRAY(a)					( *pEnv )->GetLongArrayElements( pEnv, (a), 0 )
	#define	UNLOCKLONGARRAY(a,b)				( *pEnv )->ReleaseLongArrayElements( pEnv, (a), (b), 0 )
	#define	SETLONGARRAY(a,b,c,d)				( *pEnv )->SetLongArrayRegion( pEnv, (a), (b), (c), (d) );	

	#define	GETOBJECTARRAYLEN(a)				( *pEnv )->GetArrayLength( pEnv, (a) )
	#define	GETOBJECTARRAYELEMENT( a, b )		( *pEnv )->GetObjectArrayElement( pEnv, (a), (b) )
	#define	SETOBJECTARRAYELEMENT( a, b, c )	( *pEnv )->SetObjectArrayElement( pEnv, (a), (b), (c) )

	#define	NEWSTRINGUTF( a )					( *pEnv )->NewStringUTF( pEnv, (a) )
	#define	GETSTRINGUTFLEN(a)					( *pEnv )->GetStringUTFLength( pEnv, (a) )
	#define	GETSTRINGUTF(a,b,c)					JNIUtils_GetString( pEnv, (a), (b), (c) )
#endif

char *JNIUtils_GetString( JNIEnv *pEnv, jstring pStr, char *strP, jint len );

#endif


