/****************************************************************************

	Copyright (c) 1998 Samizdat Productions. All Rights Reserved.
	You may use and redistribute this file subject to the restrictions
	outlined in the file 'readme.html', which is included with this
	package.

	For more free Java tools, applets, and applications, be sure and
	visit us at <http://www.tolstoy.com>. 

	See <http://www.tolstoy.com/samizdat/JavaSamples.html> for the latest
	version of this package.

	For more information, send email to <samizdat@tolstoy.com>

****************************************************************************/

#ifndef INC_RNIUtils_H
#define INC_RNIUtils_H

#ifdef __MWERKS__
	typedef	long __int32;
#endif

#include <windows.h>
#include <native.h>

#define	kErrParamErr		-50

#define EXP __declspec(dllexport)

#define	FUNC(pkg,clz,mth)			__cdecl COM_tolstoy_##pkg##_##clz##_##mth(	\
									struct HCOM_tolstoy_##pkg##_##clz *pObj

#define JSTRING						struct Hjava_lang_String*
#define JINT						long
#define	JLONG						__int64
#define JINTARRAY					struct HArrayOfInt*
#define	JLONGARRAY					struct HArrayOfLong*
#define	JSTRINGARRAY				struct HArrayOfString*

#define	CHECKNULL(a)				{ if ( (a) == NULL ) return kErrParamErr; }
#define	CHECKSIZE( a, b )			if ( ( (a) == NULL ) || ( obj_length( (a) ) < (unsigned long) (b) ) ) \
										return kErrParamErr;

#define	GETINTARRAYLEN(a)			obj_length( (a) )
#define	LOCKINTARRAY(a)				((a)->body)
#define	UNLOCKINTARRAY(a,b)
#define	SETINTARRAY(a,b,c,d)		RNIUtils_setIntArrayRegion( (a), (b), (c), (d) )

#define	GETLONGARRAYLEN(a)			obj_length( (a) )
#define	LOCKLONGARRAY(a)			((a)->body)
#define	UNLOCKLONGARRAY(a,b)
#define	SETLONGARRAY(a,b,c,d)		RNIUtils_setLongArrayRegion( (a), (b), (c), (d) )
	
#define	GETOBJECTARRAYLEN(a)				obj_length( (a) )
#define	GETOBJECTARRAYELEMENT( a, b )		( (a)->body )[ (b) ]
#define	SETOBJECTARRAYELEMENT( a, b, c )	( ( (a)->body )[ (b) ] = (c) )

#define	NEWSTRINGUTF( a )					makeJavaString( (a), strlen( (a) ) )
#define	GETSTRINGUTFLEN(a)					javaStringLength( (a) )
#define	GETSTRINGUTF(a,b,c)					javaString2CString( (a), (b), (c) )

void RNIUtils_setIntArrayRegion( struct HArrayOfInt* pArray, long st, long end, long *dataP );
void RNIUtils_setLongArrayRegion( struct HArrayOfLong* pArray, long st, long end, __int64 *dataP );

#endif
