REM this batch file compiles NativeTest.java, and creates the native code
REM header files which are used to build the native DLLs. You must change
REM the following lines to reflect where you have installed the nmacros
REM directory, and where the various SDKs are installed.

REM Note: These initial lines are the same for each of the three batch files
REM included with this package.

REM
REM the drive and path to the CodeWarrior project
REM
set PROJDRIVE=e:
set PROJHOME=e:\CODEWA~1\projects\nmacros

REM
REM the location of the SunJDK
REM
set JDKHOME=e:\jdk1.1.4

REM
REM the location of the MS JSDK
REM
set MSSDKHOME=c:\SDK-Java.20

REM
REM the location of zip.exe
REM
set ZIPHOME=c:\infozip

REM
REM the name of the .zip file which will contain the Java app
REM
set ZIPFILENAME=ntest.zip

REM
REM derived from the package and class name
REM
set FULLCLASSNAME=COM.tolstoy.nativetest.NativeTest
set ORIGINALHFILE=COM_tolstoy_nativetest_NativeTest.h

REM
REM name of the JNI native header file
REM
set JNIHFILE=JNI_main.h

REM
REM name of the RNI native header file
REM
set RNIHFILE=RNI_main.h


REM
REM first, compile NativeTest.java using the SunJDK
REM
%PROJDRIVE%
cd %PROJHOME%
deltree tempstuf
mkdir tempstuf

set CLASSPATH=.;%JDKHOME%\lib\classes.zip

%JDKHOME%\bin\javac -d tempstuf COM\tolstoy\nativetest\*.java

REM
REM zip the NativeTest.class, and move the .zip file into the project directory
REM
cd tempstuf
%ZIPHOME%\zip -r -0 %ZIPFILENAME% COM
move %ZIPFILENAME% %PROJHOME%

cd %PROJHOME%

REM
REM use javah to create the native code header file
REM
set classpath=.;%PROJHOME%\%ZIPFILENAME%;%JDKHOME%\lib\classes.zip
%JDKHOME%\bin\javah -jni %FULLCLASSNAME%
copy %ORIGINALHFILE% %PROJHOME%\jni\%JNIHFILE%

REM
REM use msjavah to create the native code header file
REM
set classpath=.;%PROJHOME%\%ZIPFILENAME%
%MSSDKHOME%\bin\msjavah %FULLCLASSNAME%
copy %ORIGINALHFILE% %PROJHOME%\rni\%RNIHFILE%

del %ORIGINALHFILE%
