/****************************************************************************

	Copyright (c) 1998 Samizdat Productions. All Rights Reserved.
	You may use and redistribute this file subject to the restrictions
	outlined in the file 'readme.html', which is included with this
	package.

	For more free Java tools, applets, and applications, be sure and
	visit us at <http://www.tolstoy.com>. 

	See <http://www.tolstoy.com/samizdat/JavaSamples.html> for the latest
	version of this package.

	For more information, send email to <samizdat@tolstoy.com>

****************************************************************************/

//	contains the native methods

#include "jniSwitch.h"
#include "jmacros.h"

#include <windows.h>
#include "main.h"


	//	totals the elements in 'pInArray', and returns the number of elements in 'pInArray' in
	//	the first element of 'pOutArray', and the total in the second element of 'pOutArray'

EXP JINT FUNC( nativetest, NativeTest, intTest ),
JINTARRAY pInArray,
JINTARRAY pOutArray )
{
	JINT			*arrayP;
	long			arrayLen, arrayIndex, total, i;

	CHECKSIZE( pInArray, 1 );
	CHECKSIZE( pOutArray, 2 );
	arrayLen = GETOBJECTARRAYLEN( pInArray );
	
	arrayP = LOCKINTARRAY( pInArray );

	for ( total = 0, arrayIndex = 0; arrayIndex < arrayLen; arrayIndex++ )
		total += arrayP[ arrayIndex ];

	UNLOCKINTARRAY( pInArray, arrayP );	//	arrayP *must* be the same value returned from LOCKINTARRAY
	
	SETINTARRAY( pOutArray, 0, 1, &arrayLen );
	SETINTARRAY( pOutArray, 1, 1, &total );

	return arrayLen;
}

	//	totals the elements in 'pInArray', and returns the number of elements in 'pInArray' in
	//	the first element of 'pOutArray', and the total in the second element of 'pOutArray'

EXP JLONG FUNC( nativetest, NativeTest, longTest ),
JLONGARRAY pInArray,
JLONGARRAY pOutArray )
{
	JLONG			*arrayP, arrayLen, total;
	long			arrayIndex, i;

	CHECKSIZE( pInArray, 1 );
	CHECKSIZE( pOutArray, 2 );
	arrayLen = GETOBJECTARRAYLEN( pInArray );
	
	arrayP = LOCKLONGARRAY( pInArray );

	for ( total = 0, arrayIndex = 0; arrayIndex < arrayLen; arrayIndex++ )
		total += arrayP[ arrayIndex ];

	UNLOCKLONGARRAY( pInArray, arrayP );	//	arrayP *must* be the same value returned from LOCKLONGARRAY
	
	SETLONGARRAY( pOutArray, 0, 1, &arrayLen );
	SETLONGARRAY( pOutArray, 1, 1, &total );

	return arrayLen;
}

	//	add 1 to each character of 's', and puts the modified string in each
	//	element of 'outArray'

EXP JINT FUNC( nativetest, NativeTest, stringTest ),
JSTRING pInString,
JSTRINGARRAY pOutArray )
{
	JSTRING			newJString;
	char			buf[ 256 ];
	long			strLen, arrayLen, arrayIndex, i;

	CHECKNULL( pInString );
	CHECKSIZE( pOutArray, 1 );

	GETSTRINGUTF( pInString, buf, sizeof(buf) );
	strLen = strlen( buf );
	
	arrayLen = GETOBJECTARRAYLEN( pOutArray );
	for ( arrayIndex = 0; arrayIndex < arrayLen; arrayIndex++ ) {
		for ( i = 0; i < strLen; i++ )
			++buf[ i ];
		
		newJString = NEWSTRINGUTF( buf );
		SETOBJECTARRAYELEMENT( pOutArray, arrayIndex, newJString );
	}

	return arrayLen;
}

